package eu.dnetlib.openaire.usermanagement.utils;

import org.springframework.stereotype.Component;

@Component("AuthorizationService")
public class AuthorizationService {

    public final String PORTAL_ADMIN = "PORTAL_ADMINISTRATOR";

    private String mapType(String type) {
        if(type.equals("organization")) {
            type = "institution";
        }
        if(type.equals("ri")) {
            type = "community";
        }
        return type;
    }

    /**
     * Type = FUNDER | COMMUNITY | INSTITUTION | PROJECT
     *
     * */
    public String curator(String type) {
        return "CURATOR_" + mapType(type).toUpperCase();
    }

    /**
     * Type = FUNDER | COMMUNITY | INSTITUTION | PROJECT
     *
     * Id = EE, EGI, etc
     * */
    public String manager(String type, String id) {
        return mapType(type).toUpperCase() + "_" + id.toUpperCase() + "_MANAGER";
    }

    /**
     * Type = FUNDER | COMMUNITY | INSTITUTION | PROJECT
     *
     * Id = EE, EGI, etc
     * */
    public String member(String type, String id) {
        return mapType(type).toUpperCase() + "_" + id.toUpperCase();
    }

    public boolean isCommunity(String type) {
        return mapType(type).equals("community");
    }
}
